#!/usr/bin/python3

# -*- coding: UTF-8 -*-
from http.server import BaseHTTPRequestHandler, HTTPServer
from escpos.printer import Usb, Serial, File
#import re
import os

class GP(BaseHTTPRequestHandler):
  def do_HEAD(self):
    self.send_response(404)
    self.end_headers()
  def do_GET(self):
    self.send_response(404)
    self.end_headers()

  def do_POST(self):
    length = int(self.headers['content-length'])
    data = self.rfile.read(length) #it is bytes
    data = data.decode("utf-8")

    if self.path == '/req' and data[:5] == 'data=':
      self.send_response(200)
      self.send_header('Content-type', 'text/html')
      self.send_header('Access-Control-Allow-Origin', '*')
      self.end_headers()

      data = data[5:] #strip data=
      data = data.split('&') #remove not used parameters
      data = data[0] #take data parameter only

      resp = self.doPRINT(data) #magic

      self.wfile.write(resp.encode("utf-8")) #bytes(string, "utf-8") or string.encode("utf-8")
    else:
      self.send_response(404)
      self.end_headers()

  def doPRINT(self, data):
    result = '' #Наименование_команды;код_ответа;текст_ответа;ответ_ядра XML BASE64URL;
    connected = True

    digits = 20

    try:
      #INIT HERE
      #prnt = File("/dev/usb/lp0") #/dev/usb/lp0
      #prnt = File(os.path.join(os.path.abspath(os.path.dirname(__file__)))+"output.txt")
      prnt = File(os.path.normpath(os.path.join(os.path.abspath(os.path.dirname(__file__)))+"/output.txt"))
      #prnt = Serial("/dev/ttyS3", 19200)
      #prnt.charcode("CIRILLIC2") #set encoding and send control sequence to printer
      #prnt.charcode_nosend("CIRILLIC2") #set encoding NOT send control sequence
	  #prnt._raw('')
      #prnt = File("/tmp/serial") #debug with $tail -f /tmp/serial

      #IBM SUREPOS500 intergrated display
      prnt._raw(b'\x00\x01') #ibm mode
      prnt._raw(b'\x02\x04') #cyrillic 855
      #prnt._raw(b'\x12') #Normal-display control mode (11) <DC1>
      prnt._raw(b'\x14') #cursor off
      prnt.charcode_nosend("CP855") #encode to 855
      #IBM SUREPOS500 intergrated display

    except Exception as e:
      print(e)
      connected = False

    for l in data.strip().splitlines():
      d = l.strip().split(';')

      #reset print settings to default
      if connected:
        #prnt.set(align='left', font='a', text_type='normal', width=1, height=1, density=9, invert=False, smooth=False, flip=False)
        pass

      if not connected:
        result += d[0]+";255;Нет связи c дисплеем;;\n"

      elif d[0]=='p': #p;ЛИНИЯ 1;ЛИНИЯ 2; выводит текст
        try:
          prnt.text("\n\n\r") #clear
          if(d[1]):
            prnt.text(d[1][:digits])
            if(d[2]):
              if len(d[1])<digits:
                prnt.text("\n\r")
              prnt.text(d[2][:digits-1]) #-1 чтобы не стиралась первая строка, иначе происходит перенос
            elif len(d[1])>digits:
              prnt.text(d[1].strip()[digits:digits*2-1]) #-1 чтобы не стиралась первая строка, иначе происходит перенос
          result += d[0]+";0;Успешно;;\n"
        except Exception as e:
          result += d[0]+";2;"+format(e)+";;\n"
      else:
        result += d[0]+";0;Команда не поддерживается;;\n"

    return result

def run(server_class=HTTPServer, handler_class=GP, port=8889):
  try:
    server_address = ('0.0.0.0', port)
    httpd = server_class(server_address, handler_class)
    print('Server running at localhost:8889...')
    httpd.serve_forever()
  except KeyboardInterrupt:
    print(' KeyboardInterrupt received, shutting down server')
    httpd.socket.close()

run()
